#include "dll_api.h"

//****** INTERNAL FUNCS
CApp TheApp;

map<int, bool> sensorStatus;
map<int, bool> turnoutStatus;

CMainWin* getWindowHandle() {
	//in version 2, get window via EnumWindows etc.
	return (CMainWin*) TheApp.GetMainWnd();
}

void sendSensorStatus(map<int,Sensor*> &sns) {
	map<int,Sensor*>::iter
}

void sendTurnOutStatus(map<int,Sensor*> &tns) {

}


//****** API FOLLOWS

short _stdcall Open_Ports (void) {

}

void  _stdcall Close_Ports (void) {

}

short _stdcall Initialize_Board (short, short, short, short, short) {
	//start app here?
}

short _stdcall Set_Chan_On (short, short) {

}
short _stdcall Set_Chan_Off (short, short) {

}

short _stdcall Get_Channel (short, short) {

}
short _stdcall Get_Port (short) {

}

short _stdcall Set_Port (short, short) {

}

short _stdcall TO_On (short id) {
	CMainWin* w = getWindowHandle();
	w->SendMessage(MSG_API_TO_ON, id);
}

short _stdcall TO_Off (short id) {
	CMainWin* w = getWindowHandle();
	w->SendMessage(MSG_API_TO_OFF, id);
}
short _stdcall TO_Toggle (short id) {

	CMainWin* w = getWindowHandle();
	w->SendMessage(MSG_API_TO_TOGGLE, id);
}

short _stdcall Get_TO_Status (short id) {
	map<int,bool>::iterator sn;
	sn = turnoutStatus.find((int)id);
	if(sn == turnoutStatus.end()) return 0; //not found.

	return (short) sn->second;
}

short _stdcall Get_Sensor_Status (short id) {
	map<int,bool>::iterator sn;
	sn = sensorStatus.find((int)id);
	if(sn == sensorStatus.end()) return 0; //not found.

	return (short) sn->second;
}

int _stdcall DCC_open( char comportnumber[], unsigned long& DCC_comm);
// Opens a serial port to communicate with the DCC command station 
// and establishes the required protocol: 9600,8,0,1
//
// input:  comportnumber - str "COM1" or "COM2" or ..
// output: DCC_comm - handle to the comm port
// return 0 if error
// return 1 if open and protocol accepted.
//****************************************************************************88


void _stdcall DCC_close(unsigned long DCC_comm);
// releases the comm port
//************************************************************************************



int _stdcall DCC_motor(unsigned long DCC_comm, int id, int dir, int speed);
// A System One binary command to modify a motor on a train decoder.
// The motor cmd will be buffered in the command station and 
// continually sent every 25 mu sec onto the track until another
// DCC command is sent.
// Input: id - train's long address 0 - 255
//		  dir - new direction: 1 == forward, 0 ==reverse
//  	  speed - new speed: 0-28
//
// Return: 1 -  command station took the instruction-delivery not guaranteed
//         0 -  command station did not receive the command
//         -1 - command station had problems with id
//         -2 - direction out of range
//         -3 - speed out of range
//
//************************************************************************************


int _stdcall DCC_Estop(unsigned long DCC_comm, int id, int dir);
// A System One binary command to cut the power on a train motor.
// The train will stop as soon as possible.
// Choosing the DCC_motor() fucntion with speed = 0 will cause 
// the motor will brake according to the inertia programmed into the decoder.
// 
// Note: there is also a DCC_kill() function which will cut the power 
// to the entire track layout.
//************************************************************************************


int _stdcall DCC_kill(unsigned long DCC_comm);
// A System One binary command to cut the power on the main track. 
// Used as an emergency BRAKE for ALL trains.
// All train settings are zeroed by the hardware (DCC_motor and DCC_function).
// Must call DCC_reset to re-establish power to the main track.
//
// Return: 1 -  command station took the instruction.
//         0 -  command station did not receive the command
// ************************************************************************************


int _stdcall DCC_reset(unsigned long DCC_comm);
// A System One binary command to restore the power on the main track. 
// Used after the DCC_kill() is called.
// All train settings are zeroed by the hardware (DCC_motor and DCC_function).
// Must call DCC_motor() and/or DCC_function() to reset trains.
//
// Return: 1 -  command station took the instruction.
//         0 -  command station did not receive the command
// ************************************************************************************
