#include "classes.h"

/*********
	class Sensor:

	A simple state-holder.
	Triggers on entering() and leaving()

*********/

Sensor::Sensor() {
	this->id = -1;
	this->status = false;
}

Sensor::Sensor(int id) {
	this->id = id;
	this->status = false;
}

int Sensor::getId() {
	return id;
}

// called when a traincar begins to cover
void Sensor::entering(TrainCar* car) {
	char tmp[50];
	sprintf(tmp, "sensor %d covered by traincar %d", id, car->getId());
	logprint(tmp);
	status = true;
}

//called when a traincar leaves
void Sensor::leaving(TrainCar* car) {
	char tmp[50];
	sprintf(tmp, "sensor %d uncovered by traincar %d", id, car->getId());
	logprint(tmp);
	status = false;
}

bool Sensor::getStatus() {
	return status;
}
