#include "classes.h"

Train::Train() {
}

Train::Train(int id) {
	this->id = id;
	this->speed_mult = 1;
	this->speed = 0;
	this->dir = 0;
	this->derailed = false;
}

int Train::getId() {
	return id;
}
void Train::move() {

	if(this->derailed) return;

	vector<TrainCar*>::iterator p = cars.begin();
	while(p != cars.end()) {
		(*p)->move();
		p++;
	}

}
void Train::derail() {

	if(this->derailed) return;

	derailed = true;

	char tmp[80];
	sprintf(tmp, "train %d derailed", id);
	logprint(tmp);

	vector<TrainCar*>::iterator p = cars.begin();
	while(p != cars.end()) {
		if(!(*p)->isDerailed()) {
			(*p)->derail();
		}
		p++;
	}
}

void Train::addCar(TrainCar* car) {
	cars.push_back(car);
	car->setParent(this);
	car->setDirection(dir);
	car->setSpeed(speed);
	car->setSpeedMult(speed_mult);
}

void Train::removeCar(TrainCar* car) {
	vector<TrainCar*>::iterator p = cars.begin();
	while(p != cars.end()) {
		if(*p == car) {
			cars.erase(p);
			break;
		}
		p++;
	}
}
void Train::removeCar(int carId) {
	vector<TrainCar*>::iterator p = cars.begin();
	while(p != cars.end()) {
		if((*p)->getId() == carId) {
			cars.erase(p);
			break;
		}
		p++;
	}
}

void Train::setSpeed(int speed) {
	
	if(this->derailed) return;

	this->speed = speed;

	debugprint("setting speed",speed);
	vector<TrainCar*>::iterator p = cars.begin();
	while(p != cars.end()) {
		(*p)->setSpeed(speed);
		p++;
	}
}
void Train::setDirection(int dir) {
	this->dir = dir;

	vector<TrainCar*>::iterator p = cars.begin();
	while(p != cars.end()) {
		(*p)->setDirection(dir);
		p++;
	}
}

void Train::setSpeedMult(double mult) {
	this->speed_mult = mult;

	vector<TrainCar*>::iterator p = cars.begin();
	while(p != cars.end()) {
		(*p)->setSpeedMult(mult);
		p++;
	}
}

int Train::getLength() {
	int len = 0;
	vector<TrainCar*>::iterator p = cars.begin();
	while(p != cars.end()) {
		len += (*p)->getLength();
		//add space between cars here if desired.
		p++;
	}
	return len;
}
