#include "classes.h"

TurnOut::TurnOut() {

}

TurnOut::TurnOut(int id, TrackSegment* root, int rootend, TrackSegment* pos, int posend, TrackSegment* neg, int negend) {
	this->id = id;
	this->root = root;
	this->rootend = rootend;
	this->pos = pos;
	this->posend = posend;
	this->neg = neg;
	this->negend = negend;
	this->status = true; //temp to allow off() to run
	this->off();
}

void TurnOut::toggle() {
	debugprint("Toggling",id);
	if(status == true)
		this->off();
	else
		this->on();
}

//On connects root and pos
void TurnOut::on() {
	if(status == true) return;

	root->disconnect(neg);
	neg->disconnect(root);

	root->connect(rootend, pos);
	pos->connect(posend, root);

	char tmp[50];
	sprintf(tmp, "turnout %d connected tracks %d[%d] and %d[%d]", id, root->getId(), rootend, pos->getId(), posend);
	logprint(tmp);

	status = true;
}

//Off connects root and neg
void TurnOut::off() {
	if(status == false) return;

	root->disconnect(pos);
	pos->disconnect(root);

	root->connect(rootend, neg);
	neg->connect(negend, root);

	char tmp[50];
	sprintf(tmp, "turnout %d connected tracks %d[%d] and %d[%d]", id, root->getId(), rootend, neg->getId(), negend);
	logprint(tmp);

	status = false;
}

bool TurnOut::getStatus() {
	return status;
}

int TurnOut::getId() {
	return id;
}