#include "configreader.h"

ConfigReader::ConfigReader(string fname, string delims) {
	fd.open(fname.c_str());
	this->delimiters = delims;
}

ConfigReader::~ConfigReader() {
	fd.close();
}

//done when returns -1
// parses line, skipping blank lines and comment (#) lines
int ConfigReader::getEntry(vector<int> &tokens) {
  if(!fd) return -1;

  int numTokens = 0;

  string name;

  if(fd.eof()) return -1;

  getline(fd,name);

  //skip comment lines and blank lines
  while(name[0] == '#' || name.length() == 0) {
	  if(fd.eof()) return -1;
	  getline(fd,name);
  }

  size_t pos = name.find_first_of(delimiters);
  while(pos != string::npos)
  {
    ++numTokens;
    tokens.push_back(atoi(name.substr(0, pos).c_str()));
    while(delimiters.find(name[pos]) != string::npos)
    {
      ++pos; /* skip multiple consecutive delimiters */
    }
    name = name.substr(pos);
    pos = name.find_first_of(delimiters);
  }
  ++numTokens;
  tokens.push_back(atoi(name.c_str()));

  return numTokens;
}
