#ifndef SIMWIN_H
#define SIMWIN_H

//disable silly debug stl warnings
#pragma warning(disable : 4786)

#include <afxwin.h>
#include <afxdlgs.h>
#include <vector>
#include <map>
#include <string>
#include <fstream>
#include "tracksdisplay.h"
#include "classes.h"
#include "dll_api.h"

using namespace std;

class CMainWin : public CFrameWnd
{
protected:
	CDC m_memDC;
	CBitmap m_bmp;
	CBrush m_bkbrush;

	CPen m_trainPen;
	CBrush m_sensorOn;
	CBrush m_sensorOff;
	CBrush m_turnoutOn;
	CBrush m_turnoutOff;

	map<int,TrackDisplay*> tracks;
	map<int,SensorDisplay*> sensors;
	map<int,TurnOutDisplay*> turnouts;

	Simulator* sim;

	CFileDialog* m_savelog;
	CEdit m_edit;

public:
	CMainWin();

	void AppendLog(string txt);
	Simulator* getSimulator();

	void loadSystem();
	void loadTracks(string fname);
	void loadSensors(string fname);
	void loadTurnOuts(string fname);

	void drawSystem();
	void updateStatus();

	afx_msg void OnPaint();
	afx_msg void OnTimer(UINT ID);
	afx_msg void OnExit();
	afx_msg void OnLoadSystem();
	afx_msg void OnSaveLog();
	afx_msg void OnStartSimulation();
	afx_msg void OnStopSimulation();
	afx_msg void OnDestroy();

	//temporary junk to test API
	afx_msg void OnToggleT0();
	afx_msg void OnToggleT1();
	afx_msg void OnToggleT2();
	afx_msg void OnToggleT3();
	afx_msg void OnToggleT4();
	afx_msg void OnToggleT5();

	afx_msg void OnTrain1S1();
	afx_msg void OnTrain1S2();
	afx_msg void OnTrain1S3();

	afx_msg void OnTrain2S1();
	afx_msg void OnTrain2S2();
	afx_msg void OnTrain2S3();

	DECLARE_MESSAGE_MAP()
};

class CApp : public CWinApp
{
public:
	BOOL InitInstance();
};

#endif