#ifndef TRACKSDISPLAY_H
#define TRACKSDISPLAY_H

//disable silly debug stl warnings
#pragma warning(disable : 4786)

#include <afxwin.h>
#include <vector>

using namespace std;

//little internal struct.
class TrackDisplayPart
{
public:
	CPoint start;
	CPoint end;
	int simlength;
};

class TrackDisplay
{
protected:
	int id;
	vector<TrackDisplayPart*> parts;

	double PDistance(CPoint a, CPoint b);

public:
	TrackDisplay();
	TrackDisplay(int id);
	void addPart(int startx, int starty, int endx, int endy, int simlength);
	void balanceSimlength();

	void Draw(CDC &dc);
	void ToAbsolute(int dist, CPoint &pnt);
	int getId();
};

class SensorDisplay
{
protected:
	int id;
	bool status;
	CPoint loc;
	CBrush* onBrush;
	CBrush* offBrush;

public:
	SensorDisplay(int id, CPoint loc, CBrush* onBrush, CBrush* offBrush);
	void setStatus(bool status);
	void Draw(CDC &dc);
	int getId();
};

class TurnOutDisplay
{
protected:
	int id;
	bool status;
	CPoint loc;
	CPoint loc2;
	CBrush* onBrush;
	CBrush* offBrush;

public:
	TurnOutDisplay(int id, CPoint loc, CPoint loc2, CBrush* onBrush, CBrush* offBrush);
	void setStatus(bool status);
	void Draw(CDC &dc);
	int getId();
};

#endif